// RefCountBuffer implementation file

#include "RefCountBuffer.h"
#include "servererror.h"
RefCountBufferImp::RefCountBufferImp (unsigned int size, const char *buffer) :
	_buf	(NULL),
	_size	(0)
{
		if (size != 0) {
			_buf = new char[size];
			if (_buf==NULL) throw ServerError(MEM_ERR);
			_size = size;
		}

		if (buffer != NULL) {
			memcpy (_buf, buffer, size);
		}
}

RefCountBufferImp::~RefCountBufferImp()
{
	if (_buf != NULL)
		delete[] _buf;
}

RefCountBuffer::RefCountBuffer(unsigned int size, const char *buffer) :
	_imp (new RefCountBufferImp (size, buffer))
{
}

RefCountBuffer::~RefCountBuffer()
{
}

RefCountBuffer::RefCountBuffer (const RefCountBuffer &other) :
	_imp (other._imp)
{
}

RefCountBuffer & RefCountBuffer::operator = (const RefCountBuffer &other)
{
	_imp = other._imp;
	return *this;
}

RefCountBuffer operator + (const RefCountBuffer &x, const RefCountBuffer &y)
{
	RefCountBuffer sum (x.get_size() + y.get_size());

	memcpy(sum.get_data(), x.get_data(), x.get_size());
	memcpy(sum.get_data() + x.get_size(), y.get_data(), y.get_size());

	return sum;
}