// handleclient.cpp
// Function for handling client (the main thread)
/*---------------------------------------------------------------------------*/
#include <stdlib.h>
#include <winsock2.h>
#include <stdio.h>
#include "server.h"
#include "servererror.h"
#include "handleclient.h"
#include "syncobj.h"
#include <process.h>
/*---------------------------------------------------------------------------*/
void HandleSingleClientThread (LPVOID lpParameter)
{
	ThreadParameters *p = (ThreadParameters *)lpParameter;
	
	try 
	{
		p->_server->HandleSingleClient(p->_socket);
	}

	catch (ServerError e)
	{	
		// We ignore the following errors (naive server)

		if ((e.GetErrorCode() == UNRECOGNIZED_REQUEST) ||
					 (e.GetErrorCode() == UNKNOWN_MAGIC) ||
					 (e.GetErrorCode() == RECEIVE_ERR) ||
					 (e.GetErrorCode() == SEND_ERR))
		{}
		else
		{
			// Here one can place exception handling code
		}
	}
	closesocket(p->_socket);
	p->_server->_dataLock.RequestObj();
	p->_server->_num_of_threads--;
	p->_server->_dataLock.ReleaseObj();
	delete p;
	_endthread();
}
/*---------------------------------------------------------------------------*/