// servererror.cpp
/*---------------------------------------------------------------------------*/
#include "servererror.h"
/*---------------------------------------------------------------------------*/
ostream &operator<< (ostream &os, const ServerError &e)
{
	os<<"Error: ";
	switch (e.GetErrorCode()) {
	case CREATE_SOCKET_ERR:
		os<<"Can't create socket \n";
		break;
	case BIND_ERR:
		os<<"Can't bind socket \n";
		break;
	case LISTEN_ERR:
		os<<"Listen failed \n";
		break;
	case ACCEPT_ERR:
		os<<"Accept failed \n";
		break;
	case RECEIVE_ERR:
		os<<"Receive failed \n";
		break;
	case SEND_ERR:
		os<<"Send failed \n";
		break;
	case FILES_ERR:
		os<<"Can't open source file \n";
		break;
	case WSA_ERR:
		os<<"Can't initialize windows sockets (WSA) \n";
		break;
	case MEM_ERR:
		os<<"Not enough memory\n";
		break;
	case UNRECOGNIZED_REQUEST:
		os<<"Unknown request code from client\n";
		break;
	case UNKNOWN_MAGIC:
		os<<"Unknown magic from client\n";
		break;
	default:
		os<<"Unknown error \n";
		break;
	}

	return os;
}
/*---------------------------------------------------------------------------*/