// servererror.h
// Header file for exception handling class
/*---------------------------------------------------------------------------*/
#ifndef SERVERERROR_H
#define SERVERERROR_H
/*---------------------------------------------------------------------------*/
#include <iostream>
using namespace std;
/*---------------------------------------------------------------------------*/
/** Errors definitions */
enum { CREATE_SOCKET_ERR, BIND_ERR, LISTEN_ERR, ACCEPT_ERR,
	   RECEIVE_ERR, SEND_ERR, FILES_ERR, WSA_ERR, MEM_ERR,
	   UNRECOGNIZED_REQUEST, UNKNOWN_MAGIC, UNKNOWN_ERROR}; // Errors

/** This class includes methods for error handling
  * We use this class to create objects for Throw call 
  */
  
class ServerError 
{
public:
	/** Default Ctor */
	ServerError (int e=UNKNOWN_ERROR) : _e(e) {}

	/** Returns the error code */
	int GetErrorCode () const { return _e; }

	/** Prints error to ostream */
	friend ostream &operator<< (ostream &os, const ServerError &e);

private:
	/** Error code */
	int _e;
};
/*---------------------------------------------------------------------------*/
#endif